import ComponentBase from "../../../System/ComponentBase"

const {ccclass, property} = cc._decorator;

@ccclass
export default class EffectPlay extends ComponentBase {

    @property(cc.ParticleSystem)
    particleSys:cc.ParticleSystem=null;

    @property(cc.Animation)
    ani:cc.Animation=null;

    @property
    AutoDestroy:boolean=true;



    //---- 增加一个回调方法
    public callbackTarget:any;
    public callbackHandler:Function;



    /** 完成时执行一个回调 */
    protected callback():void
    {
        if(this.callbackHandler)
        {
            this.callbackHandler.call(this.callbackTarget);
        }
    }


    cpnLoad()
    {
        if(this.ani==null)
        {
            this.ani=this.getComponent(cc.Animation);

            if(this.ani==null)
            {
                this.ani=this.getComponentInChildren(cc.Animation);
            }
       }

        if(this.particleSys==null)
        {
            this.particleSys=this.getComponent(cc.ParticleSystem);

            if(this.particleSys==null)
            {
                this.particleSys=this.getComponentInChildren(cc.ParticleSystem);
            }
        }
        
        if(this.AutoDestroy)
        {
            if(this.particleSys)
            {
                this.cpnScheduleOnce(this, this.PlayEnd,this.particleSys.duration);
            }              
            else if( this.ani)       
            {
                this.ani.on('finished',  this.PlayEnd,    this);
            }
        }
    }

    PlayEnd()
    {
        this.callback();

        if(this.AutoDestroy)
        {
            // X.log("EffectPlay ==>>> PlayEnd");
            this.node.destroy();
        }
        else
        {
            this.node.active=false;
        }
    }

    RePlay()
    {
        this.node.active=true;

        if(this.particleSys)
        {
            this.particleSys.resetSystem();
        }       

        if(this.ani)       
        {
            this.ani.resume();
        }
    }
}
